require "import"
import "android.speech.RecognizerIntent"
import "android.speech.SpeechRecognizer"
import "android.speech.RecognitionListener"
import "com.androlua.*"
import "android.net.Uri"
import "android.content.Intent"

local boobalan = "" -- variable to store the spoken words

function saveWords(words)
    boobalan = words
end

-- Function to safely stop the SpeechRecognizer
function safeStop(speechRecognizer)
    if speechRecognizer ~= nil then
        speechRecognizer.stopListening()
        speechRecognizer.destroy()
    end
end

function startListening()
    local verbalizationDetected = false

    local recognizerIntent = Intent(RecognizerIntent.ACTION_RECOGNIZE_SPEECH)
    recognizerIntent.putExtra(RecognizerIntent.EXTRA_LANGUAGE_MODEL, RecognizerIntent.LANGUAGE_MODEL_FREE_FORM)
    recognizerIntent.putExtra(RecognizerIntent.EXTRA_LANGUAGE, "ur-PK")
    recognizerIntent.putExtra(RecognizerIntent.EXTRA_CALLING_PACKAGE, this.getPackageName())

    local speechRecognizer = SpeechRecognizer.createSpeechRecognizer(this)

    local speechListener = RecognitionListener{
        onResults = function(results)
            local data = results.getParcelableArrayList(SpeechRecognizer.RESULTS_RECOGNITION)
            if data and data.size() > 0 then
                verbalizationDetected = true
                local recognizedText = data.get(0)

                -- Save the spoken words
                saveWords(recognizedText)

                local node = service.getEditText()
                local editText = service.getText(node)

                local language = "bengali"
                local defaultLanguage = Locale.getDefault().getLanguage()
                local languageCodes = { ["bengali"] = "en" }
                local wordChangeTable = {
                    ["میرا پہلا نام"] = "syed wajeeh ul hassan naqvi",
                    ["میرا پہلا ایڈریس"] = "Mohallah Mohammed Pura near national bank main branch Narowal Pakistan",
                    ["میرا پہلا موبائل نمبر"] = "+923116674054",
                    ["میرا پہلا جی میل ایڈریس"] = "syedwajeehulhassannaqvi1@gmail.com",
                    ["مثال"] = "example"
                }

                -- Apply word changes
                for k, v in pairs(wordChangeTable) do
                    recognizedText = recognizedText:gsub(k, v)
                end

                local languageCode = languageCodes[language]
                if languageCode then
                    local wordsToTranslate = recognizedText
                    local translatedWords = ""

                    local url = "https://translate.google.com/m?sl=auto&hl=" .. defaultLanguage .. "&q=" .. Uri.encode(wordsToTranslate)
                    url = url .. "&tl=" .. languageCode

                    Http.get(url, function(status, result)
                        if status == 200 and result then
                            translatedWords = result:match('<div class="result%-container">([^<]+)</div>')
                            if translatedWords then
                                service.insertText(node, translatedWords .. ". \n")
                                this.speak(translatedWords)
                            else
                                service.speak("Translation response was invalid.")
                            end
                        else
                            service.speak("Translation failed. Check your internet connection.")
                        end
                    end)
                else
                    service.insertText(node, recognizedText .. ". \n")
                    this.speak(recognizedText)
                end
            else
                -- No verbalization detected
                service.speak("Sorry! I Did Not Understand This Message")
            end

            -- Safely stop the recognizer
            safeStop(speechRecognizer)
        end,
        onError = function(errorCode)
            local errorMessages = {
                [SpeechRecognizer.ERROR_NO_MATCH] = "Sorry! I Did Not Understand Your Message",
                [SpeechRecognizer.ERROR_SPEECH_TIMEOUT] = "Speech timeout.",
                [SpeechRecognizer.ERROR_CLIENT] = "Client error.",
                [SpeechRecognizer.ERROR_NETWORK] = "Network error.",
                [SpeechRecognizer.ERROR_NETWORK_TIMEOUT] = "Network timeout.",
                [SpeechRecognizer.ERROR_SERVER] = "Server error.",
                [SpeechRecognizer.ERROR_AUDIO] = "Audio error.",
                [SpeechRecognizer.ERROR_INSUFFICIENT_PERMISSIONS] = "Insufficient permissions."
            }
            local errorMessage = errorMessages[errorCode] or "An unexpected error occurred."
            service.speak(errorMessage)
            safeStop(speechRecognizer)
        end
    }

    speechRecognizer.setRecognitionListener(speechListener)
    speechRecognizer.startListening(recognizerIntent)
end

startListening()
return true